import TransactionService from './transaction.service'
import Axios from 'axios'

export default {
  list(config, bldg, room) {
    const ta = [
      {name: 'ndcfg.module_type_class.list', old: {name: 'DD'}}, // Module type classes
      {name: 'ndcfg.module_type.list', inner_join_ref: {module_type_class_list: 'default'}}, // Module types
      {
        name: 'nd.module.list',
        old: {bldg: bldg, room: room, is_active: false},
        inner_join_ref: {module_type_list: 'default'}
      }, // Modules
      {name: 'nd.p_port.list', inner_join_ref: {module_list: 'default'}} // Join PPorts
    ]
    return TransactionService.execute(config, ta)
  },
  list_bcds(config) {
    const ta = [
      {name: 'nd.bcd.list', old: {is_own: true, sorting_params_list: ['name']}}
    ]
    return TransactionService.execute(config, ta)
  },
  send_patch_request(config, actions) {
    return Axios.post('/api/mail_requests/send_patch_request', {actions: actions}, config)
  }
}
